/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.dicommodel.ivoct;

import java.io.IOException;
import java.util.Locale;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomStream;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.AcquisitionContextModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.CardiacSynchronizationModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.CommonInstanceReferenceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.DeviceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.EnhancedContrastBolusModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.EnhancedGeneralEquipmentModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.FrameExtractionModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.FrameOfReferenceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.ImageIOD;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.IntravascularImageAcquisitionParametersModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.IntravascularOCTAcquisitionParametersModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.IntravascularOCTImageModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.IntravascularOCTProcessingParametersModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.IntravascularOCTSeriesModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.MultiFrameDimensionModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.MultiFrameFunctionalGroupsModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SOPCommonModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SupplementalPaletteColorLookupTableModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SynchronizationModule;
import cdac.medinfo.sdk.dcm30_04.enums.EnumModuleNames;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;

import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidIODException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidModuleException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ParseException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;
/**
 * The Intravascular Optical Coherence Tomography Image IOD specifies a multi-frame image acquired on an Intravascular Optical Coherence Tomography modality
 * @author saloni
 *
 */
public class IntravascularOCTIOD extends ImageIOD 
{

	/**
	 * The Constant INTRAVASCULAR_OCT_IOD.
	 */
	public static final String INTRAVASCULAR_OCT_IOD = "Intravascular OCT IOD";

	/**
	 * The obj acquisition context module.
	 */
	AcquisitionContextModule objAcquisitionContextModule = null;

	/**
	 * The obj cardiac synchronization module.
	 */
	CardiacSynchronizationModule objCardiacSynchronizationModule = null;

	/**
	 * The obj enhanced contrast bolus module.
	 */
	EnhancedContrastBolusModule objEnhancedContrastBolusModule = null;

	/**
	 * The obj frame of reference module.
	 */
	FrameOfReferenceModule objFrameOfReferenceModule = null;

	/**
	 * The obj multi frame dimension module.
	 */
	MultiFrameDimensionModule objMultiFrameDimensionModule = null;

	/**
	 * The obj multi frame functional groups module.
	 */
	MultiFrameFunctionalGroupsModule objMultiFrameFunctionalGroupsModule = null;

	/**
	 * The obj sop common module.
	 */
	SOPCommonModule objSOPCommonModule = null;

	/**
	 * The obj synchronization module.
	 */
	SynchronizationModule objSynchronizationModule = null;

	/**
	 * The obj enhanced general equipment module.
	 */
	EnhancedGeneralEquipmentModule	objEnhancedGeneralEquipmentModule = null;

	/**
	 * The obj Device module.
	 */
	DeviceModule objDeviceModule = null;

	/**
	 * The obj Common Instance Reference module.
	 */
	CommonInstanceReferenceModule objCommonInstanceReferenceModule = null;

	/**
	 * The FrameExtractionModule Module.
	 */
	FrameExtractionModule objFrameExtractionModule = null;
	
	/**
	 * The Intravascular OCT Series Module.
	 */
	IntravascularOCTSeriesModule objIntravascularOCTSeriesModule = null;
	
	/**
	 * The Supplemental Palette Color Lookup Table Module.
	 */
	SupplementalPaletteColorLookupTableModule objSupplementalPaletteColorLookupTableModule = null;
	
	/**
	 * The Intravascular OCT Image Module.
	 */
	IntravascularOCTImageModule objIntravascularOCTImageModule = null;
	
	/**
	 * The Intravascular OCT Acquisition Parameters Module.
	 */
	IntravascularOCTAcquisitionParametersModule objIntravascularOCTAcquisitionParametersModule = null;
	
	/**
	 * The Intravascular OCT Processing Parameters Module.
	 */
	IntravascularOCTProcessingParametersModule objIntravascularOCTProcessingParametersModule = null;
	
	/**
	 * The Intravascular Image Acquisition Parameters Module.
	 */
	IntravascularImageAcquisitionParametersModule objIntravascularImageAcquisitionParametersModule = null;

	/**
	 * Instantiates a new Intravascular OCT IOD.
	 */
	public IntravascularOCTIOD()
	{
		super();
	}

	/**
	 * This constructor initializes the TransferSyntax  in its superclass IOD.
	 * 
	 * @param objITransferSyntax_ - specifies the DICOM Standard defined TransfeSyntax.
	 */
	public IntravascularOCTIOD(ITransferSyntax objITransferSyntax_)
	{
		super(objITransferSyntax_);
	}

	/**
	 * This constructor initializes the  DictionaryReader
	 * in its superclass IOD.
	 * 
	 * @param objIDictionaryReader_ - specifies the DICOM Dictionary reader to be used .
	 */
	public IntravascularOCTIOD(IDictionaryReader objIDictionaryReader_)
	{
		super(objIDictionaryReader_);
	}

	/**
	 * This constructor accepts the DataSet from the user   in its superclass IOD.
	 * 
	 * @param objIDataSet_ - specifies the data set to be set in the IOD.
	 */
	public IntravascularOCTIOD(IDataSet objIDataSet_)
	{
		super(objIDataSet_);
	}

	/**
	 * This constructor initializes the TransferSyntax and DictionaryReader in its super class IOD.
	 * 
	 * @param objITransferSyntax_ specifies the DICOM Standard defined TransfeSyntax.
	 * @param objIDictionaryReader_ specifies the DICOM Dictionary reader to be used .
	 */
	public IntravascularOCTIOD(ITransferSyntax objITransferSyntax_,IDictionaryReader objIDictionaryReader_)
	{
		super(objITransferSyntax_,objIDictionaryReader_);
	}

	/**
	 * Creates IntravascularOCTIOD IOD from a DICOM file containing IntravascularOCTIOD DICOM data.
	 * @param strFileName DICOM File with absolute path.
	 * @throws IOException Exception caused due to wrong I/O operations. 
	 * @throws ParseException signals if some parse exceptions are occurred.
	 * @throws InvalidIODException signals if some IOD exceptions are occurred.
	 */
	public IntravascularOCTIOD(String strFileName)throws IOException,InvalidIODException
	{
		super(strFileName);
		try
		{
			if(objIDataSet != null)
			{
				String strSOPClassUID = objIDataSet.getSOPClassUID();
				if(strSOPClassUID != null)
				{
					if(!strSOPClassUID.equals(EnumSOPClassUIDs.INTRAVASCULAROCTIOD.getValue()))
					{
						throw new InvalidIODException(ResourceBundleWrapper.getValue("exceptions", "InvalidIOD.FileNotMatched", new Locale(DicomConfig.createInstance().getLocale())) + INTRAVASCULAR_OCT_IOD);
					}
				}
				strSOPClassUID = null;
			}
		}
		catch(InvalidIODException iie)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(iie.getMessage());
			}
			throw iie;
		}
	}
	/**
	 * Retrieves pre-initialized instance of Acquisition Context Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return AcquisitionContextModule - instance of {@link AcquisitionContextModule}.
	 */
	public AcquisitionContextModule getAcquisitionContextModule() 
	{
		if(objAcquisitionContextModule == null)
		{
			objAcquisitionContextModule = new AcquisitionContextModule(objIDataSet);
			return objAcquisitionContextModule;
		}
		return objAcquisitionContextModule;
	}

	/**
	 * Retrieves pre-initialized instance of Cardiac Synchronization Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return CardiacSynchronizationModule - instance of {@link CardiacSynchronizationModule}.
	 */
	public CardiacSynchronizationModule getCardiacSynchronizationModule() 
	{
		if(objCardiacSynchronizationModule == null)
		{
			objCardiacSynchronizationModule = new CardiacSynchronizationModule(objIDataSet);
			return objCardiacSynchronizationModule;
		}
		return objCardiacSynchronizationModule;
	}

	/**
	 * Retrieves pre-initialized instance of Enhanced Contrast Bolus Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return EnhancedContrastBolusModule - instance of {@link EnhancedContrastBolusModule}.
	 */
	public EnhancedContrastBolusModule getEnhancedContrastBolusModule() 
	{
		if(objEnhancedContrastBolusModule == null)
		{
			objEnhancedContrastBolusModule = new EnhancedContrastBolusModule(objIDataSet);
			return objEnhancedContrastBolusModule;
		}
		return objEnhancedContrastBolusModule;
	}

	/**
	 * Retrieves pre-initialized instance of Frame Of Reference Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return FrameOfReferenceModule - instance of {@link FrameOfReferenceModule}.
	 */
	public FrameOfReferenceModule getFrameOfReferenceModule() 
	{
		if(objFrameOfReferenceModule == null)
		{
			objFrameOfReferenceModule = new FrameOfReferenceModule(objIDataSet);
			return objFrameOfReferenceModule;
		}
		return objFrameOfReferenceModule;
	}

	/**
	 * Retrieves pre-initialized instance of Multi Frame Dimension Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return MultiFrameDimensionModule - instance of {@link MultiFrameDimensionModule}.
	 */
	public MultiFrameDimensionModule getMultiFrameDimensionModule() 
	{
		if(objMultiFrameDimensionModule == null)
		{
			objMultiFrameDimensionModule = new MultiFrameDimensionModule(objIDataSet);
			return objMultiFrameDimensionModule;
		}
		return objMultiFrameDimensionModule;
	}

	/**
	 * Retrieves pre-initialized instance of Multi Frame Functional Groups Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return MultiFrameFunctionalGroupsModule - instance of {@link MultiFrameFunctionalGroupsModule}.
	 */
	public MultiFrameFunctionalGroupsModule getMultiFrameFunctionalGroupsModule()
	{
		if(objMultiFrameFunctionalGroupsModule == null)
		{
			objMultiFrameFunctionalGroupsModule = new MultiFrameFunctionalGroupsModule(objIDataSet);
			return objMultiFrameFunctionalGroupsModule;
		}
		return objMultiFrameFunctionalGroupsModule;
	}

	/**
	 * Retrieves pre-initialized instance of SOP Common Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return SOPCommonModule - instance of {@link SOPCommonModule}.
	 */
	public SOPCommonModule getSOPCommonModule()
	{
		if(objSOPCommonModule == null)
		{
			objSOPCommonModule = new SOPCommonModule(objIDataSet);
			return objSOPCommonModule;
		}
		return objSOPCommonModule;
	}

	/**
	 * Retrieves pre-initialized instance of Synchronization Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return SynchronizationModule - instance of {@link SynchronizationModule}.
	 */
	public SynchronizationModule getSynchronizationModule() 
	{
		if(objSynchronizationModule == null)
		{
			objSynchronizationModule = new SynchronizationModule(objIDataSet);
			return objSynchronizationModule;
		}
		return objSynchronizationModule;
	}

	/**
	 * Retrieves pre-initialized instance of Enhanced General Equipment Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return EnhancedGeneralEquipmentModule - instance of {@link EnhancedGeneralEquipmentModule}.
	 */
	public EnhancedGeneralEquipmentModule getEnhancedGeneralEquipmentModule() 
	{
		if(objEnhancedGeneralEquipmentModule == null)
		{
			objEnhancedGeneralEquipmentModule = new EnhancedGeneralEquipmentModule(objIDataSet);
			return objEnhancedGeneralEquipmentModule;
		}
		return objEnhancedGeneralEquipmentModule;
	}

	/**
	 * Retrieves pre-initialized instance of Device Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return DeviceModule - instance of {@link DeviceModule}.
	 */
	public DeviceModule getDeviceModule()
	{
		if(objDeviceModule == null)
		{
			objDeviceModule = new DeviceModule(objIDataSet);
			return objDeviceModule;
		}
		return objDeviceModule;
	}

	/**
	 * Retrieves pre-initialized instance of Common Instance Reference Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return CommonInstanceReferenceModule - instance of {@link CommonInstanceReferenceModule}.
	 */
	public CommonInstanceReferenceModule getCommonInstanceReferenceModule()
	{
		if(objCommonInstanceReferenceModule == null)
		{
			objCommonInstanceReferenceModule = new CommonInstanceReferenceModule(objIDataSet);
			return objCommonInstanceReferenceModule;
		}
		return objCommonInstanceReferenceModule;
	}

	/**
	 * Retrieves pre-initialized instance of Frame Extraction Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return FrameExtractionModule - instance of {@link FrameExtractionModule}.
	 */
	public FrameExtractionModule getFrameExtractionModule()
	{
		if(objFrameExtractionModule == null)
		{
			objFrameExtractionModule = new FrameExtractionModule(objIDataSet);
			return objFrameExtractionModule;
		}
		return objFrameExtractionModule;
	}
	
	
	
	
	/**
	 * Retrieves pre-initialized instance of Intravascular OCT Series Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return IntravascularOCTSeriesModule - instance of {@link IntravascularOCTSeriesModule}.
	 */
	public IntravascularOCTSeriesModule getIntravascularOCTSeriesModule()
	{
		if(objIntravascularOCTSeriesModule == null)
		{
			objIntravascularOCTSeriesModule = new IntravascularOCTSeriesModule(objIDataSet);
			return objIntravascularOCTSeriesModule;
		}
		return objIntravascularOCTSeriesModule;
	}
	
	/**
	 * Retrieves pre-initialized instance of Supplemental Palette Color Lookup Table Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return SupplementalPaletteColorLookupTableModule - instance of {@link SupplementalPaletteColorLookupTableModule}.
	 */
	public SupplementalPaletteColorLookupTableModule getSupplementalPaletteColorLookupTableModule()
	{
		if(objSupplementalPaletteColorLookupTableModule == null)
		{
			objSupplementalPaletteColorLookupTableModule = new SupplementalPaletteColorLookupTableModule(objIDataSet);
			return objSupplementalPaletteColorLookupTableModule;
		}
		return objSupplementalPaletteColorLookupTableModule;
	}
	
	/**
	 * Retrieves pre-initialized instance of Intravascular OCT Image Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return IntravascularOCTImageModule - instance of {@link IntravascularOCTImageModule}.
	 */
	public IntravascularOCTImageModule getIntravascularOCTImageModule()
	{
		if(objIntravascularOCTImageModule == null)
		{
			objIntravascularOCTImageModule = new IntravascularOCTImageModule(objIDataSet);
			return objIntravascularOCTImageModule;
		}
		return objIntravascularOCTImageModule;
	}
	
	/**
	 * Retrieves pre-initialized instance of Intravascular OCT Acquisition Parameters Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return IntravascularOCTAcquisitionParametersModule - instance of {@link IntravascularOCTAcquisitionParametersModule}.
	 */
	public IntravascularOCTAcquisitionParametersModule getIntravascularOCTAcquisitionParametersModule()
	{
		if(objIntravascularOCTAcquisitionParametersModule == null)
		{
			objIntravascularOCTAcquisitionParametersModule = new IntravascularOCTAcquisitionParametersModule(objIDataSet);
			return objIntravascularOCTAcquisitionParametersModule;
		}
		return objIntravascularOCTAcquisitionParametersModule;
	}
	
	/**
	 * Retrieves pre-initialized instance of Intravascular OCT Processing Parameters Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return IntravascularOCTProcessingParametersModule - instance of {@link IntravascularOCTProcessingParametersModule}.
	 */
	public IntravascularOCTProcessingParametersModule getIntravascularOCTProcessingParametersModule()
	{
		if(objIntravascularOCTProcessingParametersModule == null)
		{
			objIntravascularOCTProcessingParametersModule = new IntravascularOCTProcessingParametersModule(objIDataSet);
			return objIntravascularOCTProcessingParametersModule;
		}
		return objIntravascularOCTProcessingParametersModule;
	}
	
	/**
	 * Retrieves pre-initialized instance of Intravascular Image Acquisition Parameters Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return IntravascularImageAcquisitionParametersModule - instance of {@link IntravascularImageAcquisitionParametersModule}.
	 */
	public IntravascularImageAcquisitionParametersModule getIntravascularImageAcquisitionParametersModule()
	{
		if(objIntravascularImageAcquisitionParametersModule == null)
		{
			objIntravascularImageAcquisitionParametersModule = new IntravascularImageAcquisitionParametersModule(objIDataSet);
			return objIntravascularImageAcquisitionParametersModule;
		}
		return objIntravascularImageAcquisitionParametersModule;
	}

	/**
	 * This method validates Enhanced CT IOD according to the Module Table given in The DICOM Standard.
	 * The validate method fails if one of the mandatory modules are absent or any of the
	 * modules are invalid.The validate method also checks for conditional modules.
	 * 
	 * @return boolean - function status indicating success or failure.
	 * 
	 * @throws InvalidIODException - throws when IOD is invalid
	 */
	public boolean validate() throws InvalidIODException
	{
		super.validate();
		try
		{
			/*
			 * This condition checks for mandatory modules validation
			 */
			getGeneralEquipmentModule().validateModule();
			getFrameOfReferenceModule().validateModule();
			getMultiFrameFunctionalGroupsModule().validateModule();
			getMultiFrameDimensionModule().validateModule();
			getAcquisitionContextModule().validateModule();
			getSOPCommonModule().validateModule();
			getIntravascularOCTSeriesModule().validateModule();
			getIntravascularOCTImageModule().validateModule();
			getIntravascularOCTAcquisitionParametersModule().validateModule();
			getIntravascularImageAcquisitionParametersModule().validateModule();
			/*
			 * This condition checks for User Optional/Conditional modules validation
			 * For conditional modules, first the presence of the modules should be checked. Because
			 * absence of optional modules is not a problem whereas presence but invalid status of the
			 * optional module is a problem.
			 */

			if(isModulePresent(EnhancedGeneralEquipmentModule.objSingleCollection,objIDataSet))
				getEnhancedGeneralEquipmentModule().validateModule();
			if(isModulePresent(DeviceModule.objSingleCollection, objIDataSet))
				getDeviceModule().validateModule();
			if(isModulePresent(CommonInstanceReferenceModule.objSingleCollection, objIDataSet))
				getCommonInstanceReferenceModule().validateModule();
			if(isModulePresent(FrameExtractionModule.objSingleCollection, objIDataSet))
				getFrameExtractionModule().validateModule();
			if(isModulePresent(SupplementalPaletteColorLookupTableModule.objSingleCollection, objIDataSet))
				getSupplementalPaletteColorLookupTableModule().validateModule();
			if(isModulePresent(IntravascularOCTProcessingParametersModule.objSingleCollection, objIDataSet))
				getIntravascularOCTProcessingParametersModule().validateModule();

		}
		catch(InvalidModuleException ime)
		{
			if(DicomConfig.createInstance().isLoggingOn())
				DicomLogger.getLogger().log(ime.getMessage());
			
				throw new InvalidIODException(INTRAVASCULAR_OCT_IOD, ime);
		}
		return true;
	}
	/**
	 *  Dumps the Name of IOD,Module and corresponding Attributs of Module.
	 *  @param objIDicomStream - the Stream on which the Data is to be written.
	 *  @throws IOException - Exception is thrown indicating runtime failure of writing operation.
	 */
	public void dumpDICOMInfo(IDicomStream objIDicomStream) throws IOException
	{
		objIDicomStream.writeString(INTRAVASCULAR_OCT_IOD+ "\n");
		super.dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getAcquisitionContextModule().getClass().getSimpleName() + "\n");
		getAcquisitionContextModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getCardiacSynchronizationModule().getClass().getSimpleName() + "\n");
		getCardiacSynchronizationModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getEnhancedContrastBolusModule().getClass().getSimpleName() + "\n");
		getEnhancedContrastBolusModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getFrameOfReferenceModule().getClass().getSimpleName() + "\n");
		getFrameOfReferenceModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getMultiFrameDimensionModule().getClass().getSimpleName() + "\n");
		getMultiFrameDimensionModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getMultiFrameFunctionalGroupsModule().getClass().getSimpleName() + "\n");
		getMultiFrameFunctionalGroupsModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getSOPCommonModule().getClass().getSimpleName() + "\n");
		getSOPCommonModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getSynchronizationModule().getClass().getSimpleName() + "\n");
		getSynchronizationModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getEnhancedGeneralEquipmentModule().getClass().getSimpleName() + "\n");
		getEnhancedGeneralEquipmentModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getDeviceModule().getClass().getSimpleName() + "\n");
		getDeviceModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getCommonInstanceReferenceModule().getClass().getSimpleName() + "\n");
		getCommonInstanceReferenceModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getFrameExtractionModule().getClass().getSimpleName() + "\n");
		getFrameExtractionModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getIntravascularOCTSeriesModule().getClass().getSimpleName() + "\n");
		getIntravascularOCTSeriesModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getSupplementalPaletteColorLookupTableModule().getClass().getSimpleName() + "\n");
		getSupplementalPaletteColorLookupTableModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getIntravascularOCTImageModule().getClass().getSimpleName() + "\n");
		getIntravascularOCTImageModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getIntravascularOCTAcquisitionParametersModule().getClass().getSimpleName() + "\n");
		getIntravascularOCTAcquisitionParametersModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getIntravascularOCTProcessingParametersModule().getClass().getSimpleName() + "\n");
		getIntravascularOCTProcessingParametersModule().dumpDICOMInfo(objIDicomStream);
		
		objIDicomStream.writeString("\t" + getIntravascularImageAcquisitionParametersModule().getClass().getSimpleName() + "\n");
		getIntravascularImageAcquisitionParametersModule().dumpDICOMInfo(objIDicomStream);

	}

	/**
	 * Checks whether the Module is present in the IOD or not.
	 * @param strModuleName String value of module name 
	 * @return boolean - true if the module is present in the IOD, else false is returned.
	 */
	public boolean isModulePresent(String strModuleName)
	{
		if(!super.isModulePresent(strModuleName))
		{
			if(strModuleName == null || strModuleName.equals(""))
				return false;
			if(strModuleName.equalsIgnoreCase(EnumModuleNames.ACQUISITION_CONTEXT_MODULE.getValue()) && isModulePresent(AcquisitionContextModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.CARDIAC_SYNCHRONIZATION_MODULE.getValue()) && isModulePresent(CardiacSynchronizationModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.ENHANCED_CONTRAST_BOLUS_MODULE.getValue()) && isModulePresent(EnhancedContrastBolusModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.FRAME_OF_REFERENCE_MODULE.getValue()) && isModulePresent(FrameOfReferenceModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.MULTI_FRAME_DIMENSION_MODULE.getValue()) && isModulePresent(MultiFrameDimensionModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.MULTI_FRAME_FUNCTIONAL_GROUPS_MODULE.getValue()) && isModulePresent(MultiFrameFunctionalGroupsModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SOP_COMMON_MODULE.getValue()) && isModulePresent(SOPCommonModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SYNCHRONIZATION_MODULE.getValue()) && isModulePresent(SynchronizationModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.ENHANCED_GENERAL_EQUIPMENT_MODULE.getValue()) && isModulePresent(EnhancedGeneralEquipmentModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.DEVICE_MODULE.getValue()) && isModulePresent(DeviceModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.COMMON_INSTANCE_REFERENCE_MODULE.getValue()) && isModulePresent(CommonInstanceReferenceModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.FRAME_EXTRACTION_MODULE.getValue()) && isModulePresent(FrameExtractionModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.INTRAVASCULAR_OCT_SERIES_MODULE.getValue()) && isModulePresent(IntravascularOCTSeriesModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SUPPLEMENTAL_PALETTE_COLOR_LOOKUP_TABLE_MODULE.getValue()) && isModulePresent(SupplementalPaletteColorLookupTableModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.INTRAVASCULAR_OCT_IMAGE_MODULE.getValue()) && isModulePresent(IntravascularOCTImageModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.INTRAVASCULAR_OCT_ACQUISITION_PARAMETERS_MODULE.getValue()) && isModulePresent(IntravascularOCTAcquisitionParametersModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.INTRAVASCULAR_OCT_PROCESSING_PARAMETERS_MODULE.getValue()) && isModulePresent(IntravascularOCTProcessingParametersModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.INTRAVASCULAR_IMAGE_ACQUISITION_PARAMETERS_MODULE.getValue()) && isModulePresent(IntravascularImageAcquisitionParametersModule.objSingleCollection))
				return true;
			else
			{
				if(DicomConfig.createInstance().isLoggingOn())
				{
					DicomLogger objDicomLogger = DicomLogger.getLogger();
					objDicomLogger.log(this.getClass().getName() + " : " +ResourceBundleWrapper.getValue("status","ModuleNotPresent",new Locale(DicomConfig.createInstance().getLocale())) + strModuleName);
				}
				return false;
			}
		}
		return true;
	}

}
